--- whitetank-svn/Makefile	2008-08-13 22:38:16.000000000 +0200
+++ whitetank-dev/Makefile	2008-11-19 11:54:17.000000000 +0100
@@ -29,30 +29,30 @@
 # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 # THE POSSIBILITY OF SUCH DAMAGE.
 
-DESTDIR=/usr/local
-SBINDIR=/usr/sbin
-INCLUDEDIR=/usr/include/openais
-INCLUDEDIR_TOTEM=/usr/include/openais/totem
-INCLUDEDIR_LCR=/usr/include/openais/lcr
-INCLUDEDIR_SERVICE=/usr/include/openais/service
-MANDIR=/usr/share/man
+include Makefile.inc
+
+SBINDIR=$(PREFIX)/sbin
+INCLUDEDIR=$(PREFIX)/include/openais
+INCLUDEDIR_TOTEM=$(PREFIX)/include/openais/totem
+INCLUDEDIR_LCR=$(PREFIX)/include/openais/lcr
+INCLUDEDIR_SERVICE=$(PREFIX)/include/openais/service
+MANDIR=$(PREFIX)/share/man
 ETCDIR=/etc/ais
-LCRSODIR=/usr/libexec/lcrso
 ARCH=$(shell uname -p)
 
 ifeq (,$(findstring 64,$(ARCH)))
-LIBDIR=/usr/lib/openais
+LIBDIR=$(PREFIX)/lib/openais
 else
-LIBDIR=/usr/lib64/openais
+LIBDIR=$(PREFIX)/lib64/openais
 endif
 ifeq (s390,$(ARCH))
-LIBDIR=/usr/lib/openais
+LIBDIR=$(PREFIX)/lib/openais
 endif
 ifeq (s390x,$(ARCH))
-LIBDIR=/usr/lib64/openais
+LIBDIR=$(PREFIX)/lib64/openais
 endif
 ifeq (ia64,$(ARCH))
-LIBDIR=/usr/lib/openais
+LIBDIR=$(PREFIX)/lib/openais
 endif
 
 all:
@@ -106,29 +106,29 @@ install:
 	ln -sf libcfg.so.2.0.0 lib/libcfg.so.2
 	ln -sf libtotem_pg.so.2.0.0 exec/libtotem_pg.so.2
 
-	cp -a lib/libais.so $(DESTDIR)$(LIBDIR)
-	cp -a lib/libSaAmf.so $(DESTDIR)$(LIBDIR)
-	cp -a lib/libSaClm.so $(DESTDIR)$(LIBDIR)
-	cp -a lib/libSaCkpt.so $(DESTDIR)$(LIBDIR)
-	cp -a lib/libSaEvt.so $(DESTDIR)$(LIBDIR)
-	cp -a lib/libSaLck.so $(DESTDIR)$(LIBDIR)
-	cp -a lib/libSaMsg.so $(DESTDIR)$(LIBDIR)
-	cp -a lib/libevs.so $(DESTDIR)$(LIBDIR)
-	cp -a lib/libcpg.so $(DESTDIR)$(LIBDIR)
-	cp -a lib/libcfg.so $(DESTDIR)$(LIBDIR)
-	cp -a exec/libtotem_pg.so $(DESTDIR)$(LIBDIR)
-
-	cp -a lib/libais.so.2 $(DESTDIR)$(LIBDIR)
-	cp -a lib/libSaAmf.so.2 $(DESTDIR)$(LIBDIR)
-	cp -a lib/libSaClm.so.2 $(DESTDIR)$(LIBDIR)
-	cp -a lib/libSaCkpt.so.2 $(DESTDIR)$(LIBDIR)
-	cp -a lib/libSaEvt.so.2 $(DESTDIR)$(LIBDIR)
-	cp -a lib/libSaLck.so.2 $(DESTDIR)$(LIBDIR)
-	cp -a lib/libSaMsg.so.2 $(DESTDIR)$(LIBDIR)
-	cp -a lib/libevs.so.2 $(DESTDIR)$(LIBDIR)
-	cp -a lib/libcpg.so.2 $(DESTDIR)$(LIBDIR)
-	cp -a lib/libcfg.so.2 $(DESTDIR)$(LIBDIR)
-	cp -a exec/libtotem_pg.so.2 $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libais.so $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libSaAmf.so $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libSaClm.so $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libSaCkpt.so $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libSaEvt.so $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libSaLck.so $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libSaMsg.so $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libevs.so $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libcpg.so $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libcfg.so $(DESTDIR)$(LIBDIR)
+	$(CP) -a exec/libtotem_pg.so $(DESTDIR)$(LIBDIR)
+
+	$(CP) -a lib/libais.so.2 $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libSaAmf.so.2 $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libSaClm.so.2 $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libSaCkpt.so.2 $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libSaEvt.so.2 $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libSaLck.so.2 $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libSaMsg.so.2 $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libevs.so.2 $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libcpg.so.2 $(DESTDIR)$(LIBDIR)
+	$(CP) -a lib/libcfg.so.2 $(DESTDIR)$(LIBDIR)
+	$(CP) -a exec/libtotem_pg.so.2 $(DESTDIR)$(LIBDIR)
 
 	install -m 755 lib/libais.so.2.* $(DESTDIR)$(LIBDIR)
 	install -m 755 lib/libSaAmf.so.2.* $(DESTDIR)$(LIBDIR)
@@ -158,7 +158,7 @@ ifneq "NO" "$(STATICLIBS)"
 	install -m 755 exec/libtotem_pg.a $(DESTDIR)$(LIBDIR)
 endif
 
-	echo $(LIBDIR) > $(DESTDIR)/etc/ld.so.conf.d/openais-$(ARCH).conf
+	echo $(LIBDIR) > "$(DESTDIR)/etc/ld.so.conf.d/openais-$(ARCH).conf"
 
 	install -m 755 exec/*lcrso $(DESTDIR)$(LCRSODIR)
 
--- whitetank-svn/Makefile.inc	2008-08-13 22:38:16.000000000 +0200
+++ whitetank-dev/Makefile.inc	2008-11-19 11:54:17.000000000 +0100
@@ -29,12 +29,17 @@
 # THE POSSIBILITY OF SUCH DAMAGE.
 # Basic OS detection
 #
+CP=cp
+DESTDIR=
+PREFIX=/usr/local
 UNAME=$(shell uname)
+LCRSODIR=$(PREFIX)/libexec/lcrso
 
 ifeq "$(UNAME)" "Linux"
 	OPENAIS_COMPAT=LINUX
 endif
 ifeq "$(UNAME)" "Darwin"
+	CP=rsync
 	OPENAIS_COMPAT=DARWIN
 endif
 ifneq "" "$(findstring BSD,$(UNAME))"