Index: exec/ipc.c
===================================================================
--- exec/ipc.c	(revision 1410)
+++ exec/ipc.c	(revision 1413)
@@ -369,7 +369,8 @@
 	
 	pthread_attr_destroy (&conn_info->thread_attr);
 	pthread_mutex_destroy (&conn_info->mutex);
-	
+	pthread_mutex_destroy (&conn_info->flow_control_mutex);
+
 	list_del (&conn_info->list);
 	free (conn_info);
 }
Index: lib/evt.c
===================================================================
--- lib/evt.c	(revision 1410)
+++ lib/evt.c	(revision 1413)
@@ -245,6 +245,9 @@
 		saHandleDestroy(&channel_handle_db, handle);
 		saHandleInstancePut(&channel_handle_db, handle);
 	}
+
+	pthread_mutex_destroy(&evti->ei_dispatch_mutex);
+	pthread_mutex_destroy(&evti->ei_response_mutex);
 }
 
 /*
@@ -272,6 +275,7 @@
 		saEvtEventFree(handle);
 	}
 
+	pthread_mutex_destroy(&eci->eci_mutex);
 }
 
 /*
@@ -296,6 +300,8 @@
 	if (edi->edi_event_data) {
 		free(edi->edi_event_data);
 	}
+
+	pthread_mutex_destroy(&edi->edi_mutex);
 }
 
 static SaAisErrorT evt_recv_event(int fd, struct lib_event_data **msg)
Index: lib/cfg.c
===================================================================
--- lib/cfg.c	(revision 1410)
+++ lib/cfg.c	(revision 1413)
@@ -88,6 +88,10 @@
  */
 void cfg_handleInstanceDestructor (void *instance)
 {
+	struct cfg_instance *cfg_instance = instance;
+
+	pthread_mutex_destroy (&cfg_instance->response_mutex);
+	pthread_mutex_destroy (&cfg_instance->dispatch_mutex);
 }
 
 SaAisErrorT
Index: lib/ckpt.c
===================================================================
--- lib/ckpt.c	(revision 1410)
+++ lib/ckpt.c	(revision 1413)
@@ -155,15 +155,24 @@
  */
 void ckptHandleInstanceDestructor (void *instance)
 {
+	struct ckptInstance *ckptInstance = instance;
+
+	pthread_mutex_destroy (&ckptInstance->response_mutex);
+	pthread_mutex_destroy (&ckptInstance->dispatch_mutex);
 }
 
 void checkpointHandleInstanceDestructor (void *instance)
 {
-	return;
+	struct ckptCheckpointInstance *checkpointInstance = instance;
+
+	pthread_mutex_destroy (&checkpointInstance->response_mutex);
 }
 
 void ckptSectionIterationHandleInstanceDestructor (void *instance)
 {
+	struct ckptSectionIterationInstance *iterationInstance = instance;
+
+	pthread_mutex_destroy (&iterationInstance->response_mutex);
 }
 
 static void ckptSectionIterationInstanceFinalize (struct ckptSectionIterationInstance *ckptSectionIterationInstance)
Index: lib/amf.c
===================================================================
--- lib/amf.c	(revision 1410)
+++ lib/amf.c	(revision 1413)
@@ -101,6 +101,10 @@
 
 void amfHandleInstanceDestructor (void *instance)
 {
+	struct amfInstance *amfInstance = instance;
+
+	pthread_mutex_destroy (&amfInstance->response_mutex);
+	pthread_mutex_destroy (&amfInstance->dispatch_mutex);
 }
 
 SaAisErrorT
Index: lib/lck.c
===================================================================
--- lib/lck.c	(revision 1410)
+++ lib/lck.c	(revision 1413)
@@ -144,11 +144,14 @@
  */
 void lckHandleInstanceDestructor (void *instance)
 {
+	struct lckInstance *lckInstance = instance;
+
+	pthread_mutex_destroy (&lckInstance->response_mutex);
+	pthread_mutex_destroy (&lckInstance->dispatch_mutex);
 }
 
 void lckResourceHandleInstanceDestructor (void *instance)
 {
-	return;
 }
 
 void lckResourceHandleLockIdInstanceDestructor (void *instance)
Index: lib/cpg.c
===================================================================
--- lib/cpg.c	(revision 1410)
+++ lib/cpg.c	(revision 1413)
@@ -76,6 +76,10 @@
  */
 static void cpg_instance_destructor (void *instance)
 {
+	struct cpg_inst *cpg_inst = instance;
+
+	pthread_mutex_destroy (&cpg_inst->response_mutex);
+	pthread_mutex_destroy (&cpg_inst->dispatch_mutex);
 }
 
 
Index: lib/clm.c
===================================================================
--- lib/clm.c	(revision 1410)
+++ lib/clm.c	(revision 1413)
@@ -92,6 +92,10 @@
 
 void clmHandleInstanceDestructor (void *instance)
 {
+	struct clmInstance *clmInstance = instance;
+
+	pthread_mutex_destroy (&clmInstance->response_mutex);
+	pthread_mutex_destroy (&clmInstance->dispatch_mutex);
 }
 
 
Index: lib/msg.c
===================================================================
--- lib/msg.c	(revision 1410)
+++ lib/msg.c	(revision 1413)
@@ -131,11 +131,14 @@
  */
 void msgHandleInstanceDestructor (void *instance)
 {
+	struct msgInstance *msgInstance = instance;
+
+	pthread_mutex_destroy (&msgInstance->response_mutex);
+	pthread_mutex_destroy (&msgInstance->dispatch_mutex);
 }
 
 void queueHandleInstanceDestructor (void *instance)
 {
-	return;
 }
 
 #ifdef COMPILE_OUT
Index: lib/evs.c
===================================================================
--- lib/evs.c	(revision 1410)
+++ lib/evs.c	(revision 1413)
@@ -80,6 +80,10 @@
  */
 static void evs_instance_destructor (void *instance)
 {
+	struct evs_inst *evs_inst = instance;
+
+	pthread_mutex_destroy (&evs_inst->response_mutex);
+	pthread_mutex_destroy (&evs_inst->dispatch_mutex);
 }
 
 